'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _reactBootstrap = require('react-bootstrap');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Callout = require('../Callout');

var _Callout2 = _interopRequireDefault(_Callout);

var _reactInteractive = require('react-interactive');

var _reactInteractive2 = _interopRequireDefault(_reactInteractive);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ContentDocumentos = function (_Component) {
  _inherits(ContentDocumentos, _Component);

  function ContentDocumentos(props) {
    _classCallCheck(this, ContentDocumentos);

    var _this = _possibleConstructorReturn(this, (ContentDocumentos.__proto__ || Object.getPrototypeOf(ContentDocumentos)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(ContentDocumentos, [{
    key: '_renderTooltip',
    value: function _renderTooltip(text) {
      return _react2.default.createElement(
        _reactBootstrap.Tooltip,
        { id: 'tooltip' },
        _react2.default.createElement(
          'strong',
          null,
          text
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        _reactstrap.Col,
        {
          className: 'col-12',
          lg: this.props.size
        },
        _react2.default.createElement(
          _reactInteractive2.default,
          {
            as: 'div',
            active: {
              transition: '.2s all ease-in-out',
              transform: 'scale(.95)'
            },
            style: {
              transition: '.2s all ease-out'
            }
          },
          _react2.default.createElement(_Callout2.default, {
            fullWidth: true,
            title: function title() {
              return _react2.default.createElement(
                'wrapper',
                { style: {
                    display: 'block',
                    padding: '5px 0px'
                  }
                },
                _this2.props.children,
                _react2.default.createElement('hr', null),
                _react2.default.createElement(
                  _reactstrap.Row,
                  {
                    style: {
                      display: 'flex',
                      marginBottom: -5,
                      marginTop: 10
                    }
                  },
                  _this2.props.download && _react2.default.createElement(
                    _reactBootstrap.OverlayTrigger,
                    {
                      placement: 'top',
                      overlay: _this2._renderTooltip('Descargar documento')
                    },
                    _react2.default.createElement(
                      _reactstrap.Button,
                      {
                        style: {
                          flex: 1,
                          position: 'relative'
                        },
                        size: 'sm',
                        color: 'success',
                        onClick: function onClick(e) {
                          return e.stopPropagation();
                        }
                      },
                      _react2.default.createElement('a', {
                        href: _this2.props.download.uri,
                        download: _this2.props.download.fileName,
                        style: {
                          position: 'absolute',
                          top: 0,
                          bottom: 0,
                          left: 0,
                          right: 0
                        }
                      }),
                      _react2.default.createElement(_Icon2.default, { bootstrap: 'cloud-download' })
                    )
                  ),
                  _this2.props.download && _react2.default.createElement(
                    'wrapper',
                    null,
                    '\xA0\xA0'
                  ),
                  _this2.props.edit && _react2.default.createElement(
                    _reactBootstrap.OverlayTrigger,
                    {
                      placement: 'top',
                      overlay: _this2._renderTooltip('Editar documento')
                    },
                    _react2.default.createElement(
                      _reactstrap.Button,
                      {
                        style: {
                          flex: 1
                        },
                        size: 'sm',
                        onClick: _this2.props.edit
                      },
                      _react2.default.createElement(_Icon2.default, { bootstrap: 'pencil' })
                    )
                  ),
                  _this2.props.edit && _react2.default.createElement(
                    'wrapper',
                    null,
                    '\xA0\xA0'
                  ),
                  _this2.props.delete && _react2.default.createElement(
                    _reactBootstrap.OverlayTrigger,
                    {
                      placement: 'top',
                      overlay: _this2._renderTooltip('Eliminar documento')
                    },
                    _react2.default.createElement(
                      _reactstrap.Button,
                      {
                        style: {
                          flex: 1
                        },
                        size: 'sm',
                        color: 'danger',
                        onClick: _this2.props.delete
                      },
                      _react2.default.createElement(_Icon2.default, { bootstrap: 'trash' })
                    )
                  ),
                  _this2.props.rescue && _react2.default.createElement(
                    _reactBootstrap.OverlayTrigger,
                    {
                      placement: 'top',
                      overlay: _this2._renderTooltip('Recuperar documento')
                    },
                    _react2.default.createElement(
                      _reactstrap.Button,
                      {
                        style: {
                          flex: 1
                        },
                        size: 'sm',
                        color: 'info',
                        onClick: _this2.props.rescue
                      },
                      _react2.default.createElement(_Icon2.default, { bootstrap: 'action-undo' })
                    )
                  )
                )
              );
            },
            color: 'primary'
          })
        )
      );
    }
  }]);

  return ContentDocumentos;
}(_react.Component);

ContentDocumentos.defaultProps = {
  size: '3'
};

ContentDocumentos.propTypes = {
  children: _propTypes2.default.any,
  size: _propTypes2.default.string,
  download: _propTypes2.default.object,
  edit: _propTypes2.default.func,
  delete: _propTypes2.default.func,
  rescue: _propTypes2.default.func
};

exports.default = ContentDocumentos;