'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _reactDayPicker = require('react-day-picker');

var _reactDayPicker2 = _interopRequireDefault(_reactDayPicker);

var _reactstrap = require('reactstrap');

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _reactBootstrap = require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Translate month names
var MONTHS = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];

// Translate weekdays header
var WEEKDAYS_SHORT = ['Dom', 'Lun', 'Mar', 'Mié', 'Jue', 'Vie', 'Sáb'];

// Translate weekdays header titles
var WEEKDAYS_LONG = ['Domingo', 'Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado'];

// Translate for aria-label attribute
var LABELS = {
  nextMonth: 'Siguiente mes',
  previousMonth: 'Anterior mes'

  // Component will receive date, locale and localeUtils props
};function YearMonthForm(_ref) {
  var date = _ref.date,
      localeUtils = _ref.localeUtils,
      _onChange = _ref.onChange,
      enabledYearChange = _ref.enabledYearChange;

  var years = [];
  if (typeof enabledYearChange === 'number' || (typeof enabledYearChange === 'undefined' ? 'undefined' : _typeof(enabledYearChange)) === 'object') {
    var fromMonth = 0;
    var toMonth = 0;

    if ((typeof enabledYearChange === 'undefined' ? 'undefined' : _typeof(enabledYearChange)) === 'object') {
      if (enabledYearChange.from && enabledYearChange.to && enabledYearChange.from <= enabledYearChange.to) {
        fromMonth = parseInt((0, _moment2.default)().add(enabledYearChange.from, 'year').format('YYYY'), 10);
        toMonth = parseInt((0, _moment2.default)().add(enabledYearChange.to, 'year').format('YYYY'), 10);
      }
      if (enabledYearChange.from && enabledYearChange.to && enabledYearChange.dynamic && enabledYearChange.from <= enabledYearChange.to) {
        fromMonth = parseInt((0, _moment2.default)(date.getFullYear(), 'YYYY', true).add(enabledYearChange.from, 'year').format('YYYY'), 10);
        toMonth = parseInt((0, _moment2.default)(date.getFullYear(), 'YYYY', true).add(enabledYearChange.to, 'year').format('YYYY'), 10);
      }
    } else {
      fromMonth = parseInt(enabledYearChange <= 0 ? (0, _moment2.default)().add(enabledYearChange, 'year').format('YYYY') : (0, _moment2.default)().format('YYYY'), 10);
      toMonth = parseInt(enabledYearChange <= 0 ? (0, _moment2.default)().format('YYYY') : (0, _moment2.default)().add(enabledYearChange, 'year').format('YYYY'), 10);
    }
    for (var i = fromMonth; i <= toMonth; i += 1) {
      years.push(i);
    }
  } else if (Array.isArray(enabledYearChange)) {
    years = enabledYearChange;
  }

  return _react2.default.createElement(
    'div',
    { className: 'DayPicker-Caption' },
    _react2.default.createElement(
      'span',
      null,
      MONTHS[date.getMonth()]
    ),
    _react2.default.createElement(
      'select',
      {
        name: 'year',
        onChange: function onChange(e) {
          return _onChange(e.currentTarget.value, date.getMonth());
        },
        value: date.getFullYear()
      },
      years.map(function (year, i) {
        return _react2.default.createElement(
          'option',
          { key: i, value: year },
          year
        );
      })
    )
  );
}

YearMonthForm.propTypes = {
  date: _propTypes2.default.object,
  localeUtils: _propTypes2.default.object,
  onChange: _propTypes2.default.func,
  enabledYearChange: _propTypes2.default.any
};

var FieldDate = function (_Component) {
  _inherits(FieldDate, _Component);

  function FieldDate(props) {
    _classCallCheck(this, FieldDate);

    var _this = _possibleConstructorReturn(this, (FieldDate.__proto__ || Object.getPrototypeOf(FieldDate)).call(this, props));

    var formato = props.formato ? props.formato : 'DD/MM/YYYY';

    _this.state = {
      formato: formato,
      showOverlay: false,
      value: props.input.value && props.input.value !== '' ? (0, _moment2.default)(props.input.value, formato, true).format(formato) : '',
      selectedDay: props.input.value && props.input.value !== '' ? (0, _moment2.default)(props.input.value, formato, true).toDate() : null
    };
    _this.handleDayClick = _this.handleDayClick.bind(_this);
    _this.handleInputChange = _this.handleInputChange.bind(_this);
    _this.handleOpenDatepicker = _this.handleOpenDatepicker.bind(_this);
    _this.handleInputBlur = _this.handleInputBlur.bind(_this);
    _this.handleContainerMouseDown = _this.handleContainerMouseDown.bind(_this);
    _this.handleCleanDatepicker = _this.handleCleanDatepicker.bind(_this);
    _this.handleYearMonthChange = _this.handleYearMonthChange.bind(_this);
    return _this;
  }

  _createClass(FieldDate, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.input.value === '') {
        this.setState({
          value: '',
          selectedDay: null
        });
      } else {
        this.setState({
          value: nextProps.input.value && nextProps.input.value !== '' ? (0, _moment2.default)(nextProps.input.value, this.state.formato, true).format(this.state.formato) : '',
          selectedDay: nextProps.input.value && nextProps.input.value !== '' ? (0, _moment2.default)(nextProps.input.value, this.state.formato, true).toDate() : null
        });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearTimeout(this.clickTimeout);
    }
  }, {
    key: 'handleContainerMouseDown',
    value: function handleContainerMouseDown() {
      var _this2 = this;

      this.clickedInside = true;
      // The input's onBlur method is called from a queue right after onMouseDown event.
      // setTimeout adds another callback in the queue, but is called later than onBlur event
      this.clickTimeout = setTimeout(function () {
        _this2.clickedInside = false;
      }, 0);
    }
  }, {
    key: 'handleCleanDatepicker',
    value: function handleCleanDatepicker() {
      var _this3 = this;

      this.setState({
        value: '',
        showOverlay: false,
        selectedDay: null
      }, function () {
        _this3.props.input && _this3.props.input.onChange && _this3.props.input.onChange('');
        _this3.props.input && _this3.props.input.onBlur && _this3.props.input.onBlur('');
        _this3.props.onSelected && _this3.props.onSelected('');
      });
    }
  }, {
    key: 'handleOpenDatepicker',
    value: function handleOpenDatepicker() {
      this.setState({
        showOverlay: true
      });
      this.input.focus();
    }
  }, {
    key: 'handleInputBlur',
    value: function handleInputBlur(e) {
      var showOverlay = this.clickedInside;

      this.setState({
        showOverlay: showOverlay
      });

      // Force input's focus if blur event was caused by clicking on the calendar
      if (showOverlay) {
        // this.input.focus()
      }
    }
  }, {
    key: 'handleInputChange',
    value: function handleInputChange(e) {
      var _this4 = this;

      var value = e.target.value;

      var momentDay = (0, _moment2.default)(value, this.state.formato, true);
      if (momentDay.isValid()) {
        this.setState({
          selectedDay: momentDay.toDate(),
          value: value
        }, function () {
          _this4.daypicker.showMonth(_this4.state.selectedDay);
        });
      } else {
        this.setState({ value: value, selectedDay: null });
      }

      // if (this.props.onSelected) {
      //   this.props.onSelected(value)
      // } else {
      //   this.props.input.onChange(value)
      // }
    }
  }, {
    key: 'handleDayClick',
    value: function handleDayClick(day, _ref2) {
      var _this5 = this;

      var disabled = _ref2.disabled,
          selected = _ref2.selected;

      if (disabled) {
        return;
      }
      this.setState({
        value: (0, _moment2.default)(day).format(this.state.formato),
        selectedDay: day,
        showOverlay: false
      }, function () {
        _this5.props.input && _this5.props.input.onChange && _this5.props.input.onChange(_this5.state.value);
        _this5.props.onSelected && _this5.props.onSelected(_this5.state.value);
      });
    }
  }, {
    key: '_renderTooltip',
    value: function _renderTooltip(text) {
      return _react2.default.createElement(
        _reactBootstrap.Tooltip,
        { id: 'tooltip' },
        _react2.default.createElement(
          'strong',
          null,
          text
        )
      );
    }
  }, {
    key: 'handleYearMonthChange',
    value: function handleYearMonthChange(year, month) {
      this.setState({
        month: new Date(year, month)
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      return _react2.default.createElement(
        _reactstrap.FormGroup,
        {
          color: !this.props.meta.touched ? '' : this.props.meta.valid ? '' : 'danger',
          style: this.props.styleFormGroup,
          className: this.props.className
        },
        this.props.label && _react2.default.createElement(
          _reactstrap.Label,
          { 'for': this.props.label.replace(/ /g, '') },
          this.props.label,
          ' ',
          this.props.required && _react2.default.createElement(
            'span',
            { className: 'text-danger' },
            '*'
          )
        ),
        _react2.default.createElement(
          'div',
          { onMouseDown: this.handleContainerMouseDown },
          _react2.default.createElement(
            _reactstrap.InputGroup,
            { style: this.props.styleInputGroup },
            _react2.default.createElement('input', {
              className: 'form-control',
              readOnly: true,
              disabled: this.props.disabled,
              type: 'text',
              ref: function ref(input) {
                _this6.input = input;
              },
              placeholder: this.props.placeholder,
              value: this.state.value,
              onChange: this.handleInputChange,
              onBlur: this.handleInputBlur
            }),
            this.props.disabled && this.props.motiveDisabled && _react2.default.createElement(
              _reactBootstrap.OverlayTrigger,
              {
                placement: 'top',
                overlay: this._renderTooltip(this.props.motiveDisabled)
              },
              _react2.default.createElement(
                _reactstrap.InputGroupAddon,
                { style: { cursor: 'not-allowed' }
                },
                _react2.default.createElement(_Icon2.default, {
                  bootstrap: 'calendar'
                })
              )
            ),
            this.props.disabled && !this.props.motiveDisabled && _react2.default.createElement(
              _reactstrap.InputGroupAddon,
              {
                style: { cursor: 'not-allowed' }
              },
              _react2.default.createElement(_Icon2.default, {
                bootstrap: 'calendar'
              })
            ),
            !this.props.disabled && _react2.default.createElement(
              _reactBootstrap.OverlayTrigger,
              {
                placement: 'top',
                overlay: this._renderTooltip('Abrir calendario')
              },
              _react2.default.createElement(
                _reactstrap.InputGroupAddon,
                {
                  style: { cursor: 'pointer' },
                  onClick: this.handleOpenDatepicker },
                _react2.default.createElement(_Icon2.default, {
                  bootstrap: 'calendar'
                })
              )
            ),
            !this.props.required && _react2.default.createElement(
              _reactBootstrap.OverlayTrigger,
              {
                placement: 'top',
                overlay: this._renderTooltip('Limpiar')
              },
              _react2.default.createElement(
                _reactstrap.InputGroupAddon,
                { style: { cursor: 'pointer' }, onClick: this.handleCleanDatepicker },
                _react2.default.createElement(_Icon2.default, {
                  bootstrap: 'close'
                })
              )
            )
          ),
          this.state.showOverlay && _react2.default.createElement(
            'div',
            {
              style: {
                position: 'absolute',
                height: 325,
                zIndex: 10
              }
            },
            _react2.default.createElement(
              'div',
              {
                style: {
                  position: 'relative',
                  background: 'white',
                  boxShadow: '0 2px 5px rgba(0, 0, 0, .15)'
                }
              },
              _react2.default.createElement(_reactDayPicker2.default, _extends({
                ref: function ref(daypicker) {
                  _this6.daypicker = daypicker;
                },
                locale: 'es',
                months: MONTHS,
                weekdaysLong: WEEKDAYS_LONG,
                weekdaysShort: WEEKDAYS_SHORT,
                labels: LABELS,
                initialMonth: this.state.selectedDay || this.props.initialMonth,
                onDayClick: this.handleDayClick,
                selectedDays: this.state.selectedDay,
                month: this.state.month,
                fromMonth: this.props.fromMonth,
                toMonth: this.props.toMonth,
                disabledDays: this.props.disabledDays,
                captionElement: this.props.enabledYearChange && _react2.default.createElement(YearMonthForm, {
                  onChange: this.handleYearMonthChange,
                  enabledYearChange: this.props.enabledYearChange
                })
              }, this.props.config))
            )
          )
        ),
        this.props.meta.touched && this.props.meta.error && _react2.default.createElement(
          _reactstrap.FormFeedback,
          null,
          this.props.meta.error
        )
      );
    }
  }]);

  return FieldDate;
}(_react.Component);

FieldDate.defaultProps = {
  meta: {},
  enabledYearChange: { from: -70, to: +10, dynamic: true }
};

FieldDate.propTypes = {
  label: _propTypes2.default.string,
  required: _propTypes2.default.bool,
  input: _propTypes2.default.object,
  meta: _propTypes2.default.object,
  onSelected: _propTypes2.default.func,
  fromMonth: _propTypes2.default.object,
  toMonth: _propTypes2.default.object,
  placeholder: _propTypes2.default.string,
  formato: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  motiveDisabled: _propTypes2.default.string,
  initialMonth: _propTypes2.default.object,
  styleFormGroup: _propTypes2.default.object,
  styleInputGroup: _propTypes2.default.object,
  disabledDays: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object, _propTypes2.default.func]),
  config: _propTypes2.default.object,
  className: _propTypes2.default.string,
  enabledYearChange: _propTypes2.default.any
};

exports.default = FieldDate;