'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DragDropGhost = require('./DragDropGhost');

var _DragDropGhost2 = _interopRequireDefault(_DragDropGhost);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DragDropContainer = function (_React$Component) {
  _inherits(DragDropContainer, _React$Component);

  function DragDropContainer(props) {
    _classCallCheck(this, DragDropContainer);

    var _this = _possibleConstructorReturn(this, (DragDropContainer.__proto__ || Object.getPrototypeOf(DragDropContainer)).call(this, props));

    _this.state = {
      clickX: 0,
      clickY: 0,
      left: 0,
      top: 0,
      initialLeftOffset: 0,
      initialTopOffset: 0,
      clicked: false,
      dragging: false,
      dragged: false,
      dragStart: false
    };

    _this.handleMouseDown = _this.handleMouseDown.bind(_this);
    _this.handleTouchStart = _this.handleTouchStart.bind(_this);
    _this.startDrag = _this.startDrag.bind(_this);

    _this.handleMouseMove = _this.handleMouseMove.bind(_this);
    _this.handleTouchMove = _this.handleTouchMove.bind(_this);
    _this.drag = _this.drag.bind(_this);

    _this.handleMouseUp = _this.handleMouseUp.bind(_this);
    _this.handleTouchEnd = _this.handleTouchEnd.bind(_this);
    _this.drop = _this.drop.bind(_this);

    _this.setGhostElem = _this.setGhostElem.bind(_this);
    _this.checkForOffsetChanges = _this.checkForOffsetChanges.bind(_this);
    _this.setDraggableFalseOnChildren = _this.setDraggableFalseOnChildren.bind(_this);

    // The DOM elem we're dragging, and the elements we're dragging over.
    _this.dragElem = null;
    _this.ghostElem = null;
    _this.containerElem = null;
    _this.currentTarget = null;
    _this.prevTarget = null;
    return _this;
  }

  _createClass(DragDropContainer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.dragElem = this.ghostElem || this.containerElem;
      // capture events
      if (this.props.dragHandleClassName) {
        // if drag handles
        var elems = this.containerElem.getElementsByClassName(this.props.dragHandleClassName);
        for (var i = 0; i < elems.length; i += 1) {
          this.addListeners(elems[i]);
        }
      } else {
        // ... or not
        this.addListeners(this.containerElem);
      }
    }
  }, {
    key: 'setGhostElem',
    value: function setGhostElem(elem) {
      // this has to run _after_ the DragGhost element renders in order to get the DOM elem for that element
      this.ghostElem = elem;
    }
  }, {
    key: 'addListeners',
    value: function addListeners(elem) {
      var _this2 = this;

      elem.addEventListener('mousedown', function (e) {
        _this2.handleMouseDown(e);
      }, false);
      elem.addEventListener('touchstart', function (e) {
        _this2.handleTouchStart(e);
      }, false);
    }
  }, {
    key: 'buildCustomEvent',
    value: function buildCustomEvent(eventName) {
      var e = void 0;
      if (typeof window.CustomEvent !== 'function') {
        // we are in IE 11 and must use old-style method of creating event
        e = document.createEvent('CustomEvent');
        e.initCustomEvent(eventName, true, true, {});
      } else {
        e = new CustomEvent(eventName, { bubbles: true, cancelable: true }); // eslint-disable-line
      }
      // Add useful data to the event
      Object.assign(e, {
        dragData: this.props.dragData,
        dragElem: this.dragElem,
        sourceElem: this.containerElem
      });
      return e;
    }
  }, {
    key: 'setCurrentTarget',
    value: function setCurrentTarget(x, y) {
      // drop the z-index to get this elem out of the way, figure out what we're dragging over, then reset the z index
      this.dragElem.style.zIndex = -1;
      var target = document.elementFromPoint(x, y) || document.body;
      this.dragElem.style.zIndex = this.props.zIndex;
      // prevent it from selecting itself as the target
      this.currentTarget = this.dragElem.contains(target) ? document.body : target;
    }
  }, {
    key: 'generateEnterLeaveEvents',
    value: function generateEnterLeaveEvents(x, y) {
      // generate events as we enter and leave elements while dragging
      var prefix = this.props.targetKey;
      this.setCurrentTarget(x, y);
      if (this.currentTarget !== this.prevTarget) {
        if (this.prevTarget) {
          this.prevTarget.dispatchEvent(this.buildCustomEvent(prefix + 'DragLeave'));
        }
        if (this.currentTarget) {
          this.currentTarget.dispatchEvent(this.buildCustomEvent(prefix + 'DragEnter'));
        }
      }
      this.prevTarget = this.currentTarget;
    }
  }, {
    key: 'generateDropEvent',
    value: function generateDropEvent(x, y) {
      // generate a drop event in whatever we're currently dragging over
      this.setCurrentTarget(x, y);
      this.currentTarget.dispatchEvent(this.buildCustomEvent(this.props.targetKey + 'Drop'));
    }

    // Start the Drag

  }, {
    key: 'handleMouseDown',
    value: function handleMouseDown(e) {
      if (e.buttons === 1 && !this.props.noDragging) {
        document.addEventListener('mousemove', this.handleMouseMove);
        document.addEventListener('mouseup', this.handleMouseUp);
        this.startDrag(e.clientX, e.clientY);
      }
    }
  }, {
    key: 'handleTouchStart',
    value: function handleTouchStart(e) {
      if (!this.props.noDragging) {
        e.preventDefault();
        document.addEventListener('touchmove', this.handleTouchMove);
        document.addEventListener('touchend', this.handleTouchEnd);
        this.startDrag(e.targetTouches[0].pageX, e.targetTouches[0].pageY);
      }
    }
  }, {
    key: 'startDrag',
    value: function startDrag(x, y) {
      document.addEventListener(this.props.targetKey + 'Dropped', this.props.onDrop);
      this.setState({
        clicked: true,
        clickX: x - this.state.left,
        clickY: y - this.state.top,
        initialLeftOffset: this.state.dragged ? this.state.initialLeftOffset : this.containerElem.offsetLeft,
        initialTopOffset: this.state.dragged ? this.state.initialTopOffset : this.containerElem.offsetTop
      });
      // this.props.onDragStart(this.props.dragData);
    }

    // During Drag

  }, {
    key: 'handleMouseMove',
    value: function handleMouseMove(e) {
      if (!this.props.noDragging) {
        e.preventDefault();
        if (this.state.clicked) {
          this.drag(e.clientX, e.clientY);
        }
      }
    }
  }, {
    key: 'handleTouchMove',
    value: function handleTouchMove(e) {
      if (!this.props.noDragging) {
        e.preventDefault();
        if (this.state.clicked) {
          this.drag(e.targetTouches[0].pageX, e.targetTouches[0].pageY);
        }
      }
    }
  }, {
    key: 'drag',
    value: function drag(x, y) {
      var _this3 = this;

      if (!this.state.dragStart) {
        this.setState({
          dragStart: true
        }, function () {
          return _this3.props.onDragStart(_this3.props.dragData);
        });
      }
      console.log('drag');
      // drop the z-index, figure out what element we're dragging over, then reset the z index
      this.generateEnterLeaveEvents(x, y);

      var _checkForOffsetChange = this.checkForOffsetChanges(),
          _checkForOffsetChange2 = _slicedToArray(_checkForOffsetChange, 2),
          dx = _checkForOffsetChange2[0],
          dy = _checkForOffsetChange2[1];

      var stateChanges = { dragging: true };
      if (!this.props.yOnly) {
        stateChanges.left = dx + x - this.state.clickX;
      }
      if (!this.props.xOnly) {
        stateChanges.top = dy + y - this.state.clickY;
      }
      this.setState(stateChanges);
      this.props.onDrag(this.props.dragData, this.currentTarget, x, y);
    }

    // Drop

  }, {
    key: 'handleMouseUp',
    value: function handleMouseUp(e) {
      this.setState({ clicked: false });
      if (this.state.dragging) {
        document.removeEventListener('mousemove', this.handleMouseMove);
        document.removeEventListener('mouseup', this.handleMouseUp);
        this.drop(e.clientX, e.clientY);
      }
    }
  }, {
    key: 'handleTouchEnd',
    value: function handleTouchEnd(e) {
      this.setState({ clicked: false });
      if (this.state.dragging) {
        document.removeEventListener('touchmove', this.handleTouchMove);
        document.removeEventListener('touchend', this.handleTouchEnd);
        this.drop(e.changedTouches[0].pageX, e.changedTouches[0].pageY);
      }
    }
  }, {
    key: 'drop',
    value: function drop(x, y) {
      // document.removeEventListener(`${this.props.targetKey}Dropped`, this.handleDrop);
      this.generateDropEvent(x, y);
      if (this.containerElem) {
        if (this.props.returnToBase) {
          this.setState({ left: 0, top: 0, dragging: false });
        } else {
          this.setState({ dragged: true, dragging: false });
        }
      }
      this.setState({
        dragStart: false
      }, this.props.onDragEnd(this.props.dragData, this.currentTarget, x, y));
    }
  }, {
    key: 'checkForOffsetChanges',
    value: function checkForOffsetChanges() {
      // deltas for when the system moves, e.g. from other elements on the page that change size on dragover.
      var dx = void 0;
      var dy = void 0;
      if (this.props.customDragElement || this.props.dragClone) {
        dx = this.state.initialLeftOffset - this.containerElem.offsetLeft;
        dy = this.state.initialTopOffset - this.containerElem.offsetTop;
      } else {
        dx = this.state.initialLeftOffset + this.state.left - this.containerElem.offsetLeft;
        dy = this.state.initialTopOffset + this.state.top - this.containerElem.offsetTop;
      }
      return [dx, dy];
    }
  }, {
    key: 'setDraggableFalseOnChildren',
    value: function setDraggableFalseOnChildren() {
      // because otherwise can conflict with built-in browser dragging behavior
      var inputReactObject = _react2.default.Children.only(this.props.children);
      var clonedChild = _react2.default.cloneElement(inputReactObject, {
        draggable: 'false'
      });
      return clonedChild;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var styles = {
        position: 'relative'
      };

      var ghost = '';
      if (this.props.customDragElement || this.props.dragClone) {
        // dragging will be applied to the DragDropGhost element
        var ghostContent = void 0;
        if (this.props.customDragElement) {
          ghostContent = this.props.customDragElement;
        } else {
          ghostContent = this.setDraggableFalseOnChildren(); // dragging a clone
        }

        ghost = _react2.default.createElement(
          _DragDropGhost2.default,
          {
            dragging: this.state.dragging, left: this.state.left, top: this.state.top, zIndex: this.props.zIndex,
            setGhostElem: this.setGhostElem
          },
          _react2.default.createElement(
            'div',
            { style: { opacity: this.props.dragCloneOpacity, cursor: 'move' } },
            ghostContent
          )
        );
      } else {
        // dragging will be applied to the DragDropContainer itself
        styles.left = this.state.left;
        styles.top = this.state.top;
        styles.zIndex = this.state.dragging || this.state.dragged ? this.props.zIndex : 'inherit';
        styles.cursor = this.state.dragging ? 'move' : 'pointer';
      }
      return _react2.default.createElement(
        'div',
        { style: styles, ref: function ref(container) {
            _this4.containerElem = container;
          } },
        this.setDraggableFalseOnChildren(),
        ghost
      );
    }
  }]);

  return DragDropContainer;
}(_react2.default.Component);

DragDropContainer.propTypes = {
  children: _react2.default.PropTypes.node.isRequired,

  // Determines what you can drop on
  targetKey: _react2.default.PropTypes.string,

  // If provided, we'll drag this instead of the actual object. Takes priority over dragClone if both are set
  customDragElement: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.node]),

  // If true, then we will drag a clone of the object instead of the object itself. See also customDragElement
  dragClone: _react2.default.PropTypes.bool,

  // ghost will display with this opacity
  dragCloneOpacity: _react2.default.PropTypes.number,

  // We will pass this data to the target when you drag or drop over it
  dragData: _react2.default.PropTypes.object,

  // If included, we'll only let you drag by grabbing elements with this className
  dragHandleClassName: _react2.default.PropTypes.string,

  // if True, then dragging is turned off
  noDragging: _react2.default.PropTypes.bool,

  // callbacks (optional):
  onDrop: _react2.default.PropTypes.func,
  onDrag: _react2.default.PropTypes.func,
  onDragEnd: _react2.default.PropTypes.func,
  onDragStart: _react2.default.PropTypes.func,

  // If true, then object will return to its starting point after you let go of it
  returnToBase: _react2.default.PropTypes.bool,

  // Constrain dragging to the x or y directions only
  xOnly: _react2.default.PropTypes.bool,
  yOnly: _react2.default.PropTypes.bool,

  // Defaults to 1000 while dragging, but you can customize it if you need it to go higher
  zIndex: _react2.default.PropTypes.number
};

DragDropContainer.defaultProps = {
  targetKey: 'ddc',
  customDragElement: null,
  dragClone: false,
  dragCloneOpacity: 0.9,
  dragData: {},
  dragHandleClassName: '',
  onDragStart: function onDragStart() {},
  onDrag: function onDrag() {},
  onDragEnd: function onDragEnd() {},
  onDrop: function onDrop() {},
  noDragging: false,
  returnToBase: false,
  xOnly: false,
  yOnly: false,
  zIndex: 1000
};

exports.default = DragDropContainer;