'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DropTarget = function (_React$Component) {
  _inherits(DropTarget, _React$Component);

  function DropTarget(props) {
    _classCallCheck(this, DropTarget);

    var _this = _possibleConstructorReturn(this, (DropTarget.__proto__ || Object.getPrototypeOf(DropTarget)).call(this, props));

    _this.elem = null;
    _this.handleDrop = _this.handleDrop.bind(_this);
    return _this;
  }

  _createClass(DropTarget, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      this.elem.addEventListener(this.props.targetKey + 'DragEnter', function (e) {
        _this2.props.onDragEnter(e);
      }, false);
      this.elem.addEventListener(this.props.targetKey + 'DragLeave', function (e) {
        _this2.props.onDragLeave(e);
      }, false);
      this.elem.addEventListener(this.props.targetKey + 'Drop', function (e) {
        _this2.handleDrop(e);
      }, false);
    }
  }, {
    key: 'createEvent',
    value: function createEvent(eventName, eventData) {
      // utility to create an event
      var e = void 0;
      if (typeof window.CustomEvent !== 'function') {
        // we are in IE 11 and must use old-style method of creating event
        e = document.createEvent('CustomEvent');
        e.initCustomEvent(eventName, true, true, {});
      } else {
        e = new CustomEvent(eventName, { bubbles: true, cancelable: true }); // eslint-disable-line
      }
      Object.assign(e, eventData);
      return e;
    }
  }, {
    key: 'handleDrop',
    value: function handleDrop(e) {
      // tell the drop source about the drop, then do the callback
      var evt = this.createEvent(this.props.targetKey + 'Dropped', { dropElem: this.elem, dropData: this.props.dropData });
      e.sourceElem.dispatchEvent(evt);
      this.props.onHit(e);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return _react2.default.createElement(
        'span',
        { ref: function ref(t) {
            _this3.elem = t;
          } },
        this.props.children
      );
    }
  }]);

  return DropTarget;
}(_react2.default.Component);

DropTarget.propTypes = {
  children: _react2.default.PropTypes.node.isRequired,

  // needs to match the targetKey in the DragDropContainer
  targetKey: _react2.default.PropTypes.string,

  // data that gets sent back to the DragDropContainer and shows up in its onDrop() callback event
  dropData: _react2.default.PropTypes.object,

  // callbacks
  onDragEnter: _react2.default.PropTypes.func,
  onDragLeave: _react2.default.PropTypes.func,
  onHit: _react2.default.PropTypes.func
};

DropTarget.defaultProps = {
  targetKey: 'ddc',
  onDragEnter: function onDragEnter() {},
  onDragLeave: function onDragLeave() {},
  onHit: function onHit() {
    return function () {};
  },
  dropData: {}
};

exports.default = DropTarget;