'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _reactBootstrap = require('react-bootstrap');

var _reactDropzone = require('react-dropzone');

var _reactDropzone2 = _interopRequireDefault(_reactDropzone);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FieldGroupFile = function (_Component) {
  _inherits(FieldGroupFile, _Component);

  function FieldGroupFile(props) {
    _classCallCheck(this, FieldGroupFile);

    var _this = _possibleConstructorReturn(this, (FieldGroupFile.__proto__ || Object.getPrototypeOf(FieldGroupFile)).call(this, props));

    var file = false;
    var restore = false;
    if (props.input) {
      file = props.input.value;
      restore = props.input.value;
    }

    _this.state = {
      file: file,
      restore: restore,
      btnRestore: false
    };
    _this.onDrop = _this.onDrop.bind(_this);
    _this.deleteFILE = _this.deleteFILE.bind(_this);
    _this.restoreFILE = _this.restoreFILE.bind(_this);
    return _this;
  }

  _createClass(FieldGroupFile, [{
    key: 'onDrop',
    value: function onDrop(file, reject) {
      var _this2 = this;

      var promise = new Promise(function (resolve, reject) {
        var reader = new FileReader(); // eslint-disable-line
        reader.readAsDataURL(file[0]);
        reader.onload = function () {
          if (reader.result) {
            resolve(reader.result);
          } else {
            reject(Error('Failed converting to base64'));
          }
        };
      });
      promise.then(function (result) {
        _this2.setState({
          file: {
            fileName: file[0].name,
            fileSize: file[0].size,
            fileType: file[0].type,
            base64: result.split(',')[1]
          },
          btnRestore: true
        }, function () {
          _this2.props.input && _this2.props.input.onChange(_this2.state.file);
          _this2.props.onSelect && _this2.props.onSelect(_this2.state.file);
        });
      }, function (err) {
        console.log(err);
      });
    }
  }, {
    key: 'deleteFILE',
    value: function deleteFILE(e) {
      var _this3 = this;

      e.stopPropagation();
      this.setState({
        file: false,
        btnRestore: true
      }, function () {
        _this3.props.input && _this3.props.input.onChange('');
        _this3.props.input && _this3.props.input.onBlur('');
        _this3.props.onSelect && _this3.props.onSelect('');
      });
    }
  }, {
    key: 'restoreFILE',
    value: function restoreFILE(e) {
      var _this4 = this;

      e.stopPropagation();
      this.setState({
        file: this.state.restore,
        btnRestore: false
      }, function () {
        _this4.props.input && _this4.props.input.onChange(_this4.state.file);
      });
    }
  }, {
    key: '_renderTooltip',
    value: function _renderTooltip(text) {
      return _react2.default.createElement(
        _reactBootstrap.Tooltip,
        { id: 'tooltip' },
        _react2.default.createElement(
          'strong',
          null,
          text
        )
      );
    }
  }, {
    key: '_renderFieldInput',
    value: function _renderFieldInput(_ref) {
      var autocomplete = _ref.autocomplete,
          icon = _ref.icon,
          label = _ref.label,
          input = _ref.input,
          stylesInput = _ref.stylesInput,
          props = _objectWithoutProperties(_ref, ['autocomplete', 'icon', 'label', 'input', 'stylesInput']);

      return _react2.default.createElement(
        _reactstrap.InputGroup,
        null,
        _react2.default.createElement(
          _reactBootstrap.OverlayTrigger,
          {
            placement: 'top',
            overlay: this._renderTooltip('Agregar archivo')
          },
          _react2.default.createElement(
            _reactstrap.InputGroupAddon,
            {
              style: {
                cursor: 'pointer',
                overflow: 'hidden',
                position: 'relative'
              }
            },
            _react2.default.createElement(_reactDropzone2.default, {
              onDrop: this.onDrop,
              multiple: false,
              accept: this.props.accept,
              name: this.props.name,
              style: {
                position: 'absolute',
                top: 0,
                left: 0,
                right: 0,
                bottom: 0
              }
            }),
            (icon.bootstrap || icon.awesome) && _react2.default.createElement(_Icon2.default, {
              bootstrap: icon.bootstrap,
              awesome: icon.awesome,
              style: icon.style
            })
          )
        ),
        _react2.default.createElement(_reactstrap.Input, {
          id: label && label.replace(/ /g, ''),
          autoComplete: autocomplete ? 'on' : 'off',
          type: 'text',
          style: stylesInput,
          value: this.state.file ? this.state.file.fileName : '',
          readOnly: true
        }),
        this.state.restore && this.state.btnRestore && _react2.default.createElement(
          _reactstrap.InputGroupAddon,
          { style: { display: 'flex', padding: 0 } },
          _react2.default.createElement(
            _reactBootstrap.OverlayTrigger,
            {
              placement: 'top',
              overlay: this._renderTooltip('Restaurar original')
            },
            _react2.default.createElement(
              _reactstrap.Button,
              {
                style: { flex: 1 },
                size: 'sm',
                color: 'info',
                onClick: this.restoreFILE
              },
              _react2.default.createElement(_Icon2.default, { bootstrap: 'action-undo' })
            )
          )
        ),
        this.state.file && this.state.file.uri && _react2.default.createElement(
          _reactstrap.InputGroupAddon,
          { style: { display: 'flex', padding: 0, position: 'relative' } },
          _react2.default.createElement(
            _reactBootstrap.OverlayTrigger,
            {
              placement: 'top',
              overlay: this._renderTooltip('Descargar')
            },
            _react2.default.createElement(
              _reactstrap.Button,
              {
                style: { flex: 1 },
                size: 'sm',
                color: 'success',
                onClick: function onClick(e) {
                  return e.stopPropagation();
                }
              },
              _react2.default.createElement('a', {
                href: this.state.file.uri,
                download: this.state.file.fileName,
                style: {
                  position: 'absolute',
                  top: 0,
                  bottom: 0,
                  left: 0,
                  right: 0
                }
              }),
              _react2.default.createElement(_Icon2.default, { bootstrap: 'cloud-download' })
            )
          )
        ),
        this.state.file && _react2.default.createElement(
          _reactstrap.InputGroupAddon,
          { style: { display: 'flex', padding: 0 } },
          _react2.default.createElement(
            _reactBootstrap.OverlayTrigger,
            {
              placement: 'top',
              overlay: this._renderTooltip('Eliminar')
            },
            _react2.default.createElement(
              _reactstrap.Button,
              {
                style: { flex: 1 },
                size: 'sm',
                color: 'danger',
                onClick: this.deleteFILE
              },
              _react2.default.createElement(_Icon2.default, { bootstrap: 'trash' })
            )
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          horizontal = _props.horizontal,
          required = _props.required,
          meta = _props.meta,
          info = _props.info,
          className = _props.className,
          props = _objectWithoutProperties(_props, ['horizontal', 'required', 'meta', 'info', 'className']);

      return _react2.default.createElement(
        _reactstrap.FormGroup,
        {
          color: meta && !meta.touched ? '' : meta && meta.valid ? '' : 'danger',
          row: horizontal ? true : undefined,
          className: className
        },
        props.label && _react2.default.createElement(
          _reactstrap.Label,
          {
            'for': props.label.replace(/ /g, ''),
            xs: horizontal && horizontal.labelSize && horizontal.labelSize.xs ? horizontal.labelSize.xs : undefined,
            sm: horizontal && horizontal.labelSize && horizontal.labelSize.sm ? horizontal.labelSize.sm : undefined,
            md: horizontal && horizontal.labelSize && horizontal.labelSize.md ? horizontal.labelSize.md : undefined,
            lg: horizontal && horizontal.labelSize && horizontal.labelSize.lg ? horizontal.labelSize.lg : undefined,
            xl: horizontal && horizontal.labelSize && horizontal.labelSize.xl ? horizontal.labelSize.xl : undefined
          },
          props.label,
          ' ',
          required && _react2.default.createElement(
            'span',
            { className: 'text-danger' },
            '*'
          ),
          '\xA0',
          info && info !== '' && _react2.default.createElement(
            _reactBootstrap.OverlayTrigger,
            {
              placement: 'right',
              overlay: this._renderTooltip(info)
            },
            _react2.default.createElement(
              'wrapper',
              null,
              _react2.default.createElement(_Icon2.default, { bootstrap: 'info' })
            )
          )
        ),
        horizontal && _react2.default.createElement(
          _reactstrap.Col,
          {
            xs: horizontal && horizontal.inputSize && horizontal.inputSize.xs ? horizontal.inputSize.xs : undefined,
            sm: horizontal && horizontal.inputSize && horizontal.inputSize.sm ? horizontal.inputSize.sm : undefined,
            md: horizontal && horizontal.inputSize && horizontal.inputSize.md ? horizontal.inputSize.md : undefined,
            lg: horizontal && horizontal.inputSize && horizontal.inputSize.lg ? horizontal.inputSize.lg : undefined,
            xl: horizontal && horizontal.inputSize && horizontal.inputSize.xl ? horizontal.inputSize.xl : undefined
          },
          this._renderFieldInput(props),
          meta && meta.touched && meta.error && _react2.default.createElement(
            _reactstrap.FormFeedback,
            null,
            meta.error
          )
        ),
        !horizontal && this._renderFieldInput(props),
        !horizontal && meta && meta.touched && meta.error && _react2.default.createElement(
          _reactstrap.FormFeedback,
          null,
          meta.error
        )
      );
    }
  }]);

  return FieldGroupFile;
}(_react.Component);

FieldGroupFile.defaultProps = {
  autocomplete: false,
  icon: { bootstrap: 'doc' }
};

FieldGroupFile.propTypes = {
  accept: _propTypes2.default.string,
  name: _propTypes2.default.string,
  input: _propTypes2.default.object,
  meta: _propTypes2.default.object,
  className: _propTypes2.default.string,
  label: _propTypes2.default.string,
  required: _propTypes2.default.bool,
  horizontal: _propTypes2.default.bool,
  info: _propTypes2.default.string,
  onSelect: _propTypes2.default.func
};

exports.default = FieldGroupFile;