'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FieldSwitch = function (_Component) {
  _inherits(FieldSwitch, _Component);

  function FieldSwitch(props) {
    _classCallCheck(this, FieldSwitch);

    var _this = _possibleConstructorReturn(this, (FieldSwitch.__proto__ || Object.getPrototypeOf(FieldSwitch)).call(this, props));

    _this.state = {
      value: props.input.value !== '' && props.input.value !== false
    };
    _this.handlerChange = _this.handlerChange.bind(_this);
    return _this;
  }

  _createClass(FieldSwitch, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.input.value !== '' && nextProps.input.value !== this.state.value) {
        this.setState({
          value: nextProps.input.value
        });
      }
    }
  }, {
    key: 'handlerChange',
    value: function handlerChange(e) {
      var _this2 = this;

      this.setState({
        value: e.currentTarget.value === 'false'
      }, function () {
        _this2.props.input.onChange && _this2.props.input.onChange(_this2.state.value);
        _this2.props.onChanged && _this2.props.onChanged(_this2.state.value);
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          disabled = _props.disabled,
          size = _props.size,
          style = _props.style,
          label = _props.label,
          horizontal = _props.horizontal,
          right = _props.right,
          withText = _props.withText,
          pill = _props.pill,
          color = _props.color,
          outline = _props.outline,
          outlineAlt = _props.outlineAlt,
          onChanged = _props.onChanged,
          input = _props.input,
          meta = _props.meta,
          props = _objectWithoutProperties(_props, ['disabled', 'size', 'style', 'label', 'horizontal', 'right', 'withText', 'pill', 'color', 'outline', 'outlineAlt', 'onChanged', 'input', 'meta']); // eslint-disable-line


      return _react2.default.createElement(
        _reactstrap.FormGroup,
        {
          check: true,
          className: right && 'overflow-hidden',
          style: style
        },
        !horizontal && label && _react2.default.createElement(
          'wrapper',
          null,
          _react2.default.createElement(
            _reactstrap.Label,
            { 'for': label.replace(/ /g, '') },
            label
          ),
          _react2.default.createElement('br', null)
        ),
        horizontal && label && _react2.default.createElement(
          'wrapper',
          null,
          _react2.default.createElement(
            'span',
            { className: right ? 'pull-left' : '', style: { maxWidth: right ? '75%' : 'initial' } },
            label
          ),
          !right && _react2.default.createElement(
            'wrapper',
            null,
            '\xA0\xA0'
          )
        ),
        _react2.default.createElement(
          'label',
          {
            className: 'switch' + (right ? ' pull-right' : '') + (withText ? ' switch-text' : ' switch-default') + (pill ? ' switch-pill' : '') + (color ? ' switch-' + color : '') + (outline ? '-outline' : '') + (outlineAlt ? '-outline-alt' : '') + (size ? ' switch-' + size : ''),
            style: { cursor: disabled ? 'not-allowed' : '' }
          },
          _react2.default.createElement(_reactstrap.Input, {
            className: 'switch-input',
            type: props.type,
            checked: this.state.value,
            value: this.state.value,
            onChange: this.handlerChange,
            disabled: disabled
          }),
          _react2.default.createElement('span', {
            className: 'switch-label' + (disabled ? ' switch-disabled' : ''),
            'data-on': withText && withText.on,
            'data-off': withText && withText.off }),
          _react2.default.createElement('span', { className: 'switch-handle' })
        )
      );
    }
  }]);

  return FieldSwitch;
}(_react.Component);

FieldSwitch.defaultProps = {
  color: 'primary',
  size: 'md',
  disabled: false
};

FieldSwitch.propTypes = {
  label: _propTypes2.default.string,
  right: _propTypes2.default.bool,
  withText: _propTypes2.default.object,
  pill: _propTypes2.default.bool,
  color: _propTypes2.default.string,
  outline: _propTypes2.default.bool,
  outlineAlt: _propTypes2.default.bool,
  input: _propTypes2.default.object,
  meta: _propTypes2.default.object,
  horizontal: _propTypes2.default.bool,
  style: _propTypes2.default.object,
  size: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  onChanged: _propTypes2.default.func
};

exports.default = FieldSwitch;