'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = withColumnsTag;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _deepcopy = require('deepcopy');

var _deepcopy2 = _interopRequireDefault(_deepcopy);

var _reactstrap = require('reactstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function withColumnsTag(Component) {
  var withColumnsTag = function (_React$Component) {
    _inherits(withColumnsTag, _React$Component);

    function withColumnsTag(props) {
      _classCallCheck(this, withColumnsTag);

      var _this = _possibleConstructorReturn(this, (withColumnsTag.__proto__ || Object.getPrototypeOf(withColumnsTag)).call(this, props));

      _this.state = {
        columnsTag: props.columnsTag,
        columnsTagPrint: props.columnsTag
      };
      _this.setColumnsTagPrint = _this.setColumnsTagPrint.bind(_this);
      _this.handlerClickColumnsTag = _this.handlerClickColumnsTag.bind(_this);
      _this.handlerClickColumnsTagPrint = _this.handlerClickColumnsTagPrint.bind(_this);
      _this._renderColumnsTagElements = _this._renderColumnsTagElements.bind(_this);
      _this._renderColumnsTagElementsPrint = _this._renderColumnsTagElementsPrint.bind(_this);
      _this._renderColumnsTag = _this._renderColumnsTag.bind(_this);
      _this._renderColumnsTagPrint = _this._renderColumnsTagPrint.bind(_this);
      return _this;
    }

    _createClass(withColumnsTag, [{
      key: 'setColumnsTagPrint',
      value: function setColumnsTagPrint() {
        this.setState({
          columnsTagPrint: (0, _deepcopy2.default)(this.state.columnsTag)
        });
      }
    }, {
      key: 'handlerClickColumnsTag',
      value: function handlerClickColumnsTag(prop) {
        var columnsTag = this.state.columnsTag;
        columnsTag[prop] = !columnsTag[prop];

        this.setState({
          columnsTag: columnsTag
        });
      }
    }, {
      key: 'handlerClickColumnsTagPrint',
      value: function handlerClickColumnsTagPrint(prop) {
        var columnsTagPrint = this.state.columnsTagPrint;
        columnsTagPrint[prop] = !columnsTagPrint[prop];

        this.setState({
          columnsTagPrint: columnsTagPrint
        });
      }
    }, {
      key: '_renderColumnsTagElements',
      value: function _renderColumnsTagElements() {
        var _this2 = this;

        var elements = [];

        var _loop = function _loop(prop) {
          if (_this2.props.tHead[prop]) {
            elements.push(_react2.default.createElement(
              'wrapper',
              { key: prop },
              _react2.default.createElement(
                _reactstrap.Badge,
                {
                  pill: true,
                  className: 'mb-q',
                  color: _this2.state.columnsTag[prop] ? 'primary' : 'default',
                  role: 'button',
                  style: { fontSize: '.80rem' },
                  onClick: function onClick() {
                    return _this2.handlerClickColumnsTag(prop);
                  }
                },
                _this2.props.tHead[prop]
              ),
              '\xA0'
            ));
          }
        };

        for (var prop in this.state.columnsTag) {
          _loop(prop);
        }
        return elements;
      }
    }, {
      key: '_renderColumnsTag',
      value: function _renderColumnsTag() {
        if (this.state.columnsTag) {
          return _react2.default.createElement(
            _reactstrap.Row,
            null,
            _react2.default.createElement(
              _reactstrap.Col,
              { className: 'col-12 mb-q', sm: '12' },
              this._renderColumnsTagElements()
            )
          );
        } else {
          return null;
        }
      }
    }, {
      key: '_renderColumnsTagElementsPrint',
      value: function _renderColumnsTagElementsPrint() {
        var _this3 = this;

        var elements = [];

        var _loop2 = function _loop2(prop) {
          if (_this3.props.tHead[prop]) {
            elements.push(_react2.default.createElement(
              'wrapper',
              { key: prop },
              _react2.default.createElement(
                _reactstrap.Badge,
                {
                  pill: true,
                  className: 'mb-q',
                  color: _this3.state.columnsTagPrint[prop] ? 'primary' : 'default',
                  role: 'button',
                  style: { fontSize: '.80rem' },
                  onClick: function onClick() {
                    return _this3.handlerClickColumnsTagPrint(prop);
                  }
                },
                _this3.props.tHead[prop]
              ),
              '\xA0'
            ));
          }
        };

        for (var prop in this.state.columnsTagPrint) {
          _loop2(prop);
        }
        return elements;
      }
    }, {
      key: '_renderColumnsTagPrint',
      value: function _renderColumnsTagPrint() {
        if (this.state.columnsTagPrint) {
          return _react2.default.createElement(
            _reactstrap.Row,
            { className: 'hidden-print' },
            _react2.default.createElement(
              _reactstrap.Col,
              { className: 'col-12 mb-q', sm: '12' },
              this._renderColumnsTagElementsPrint()
            )
          );
        } else {
          return null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(Component, _extends({
          _renderColumnsTag: this._renderColumnsTag,
          _renderColumnsTagPrint: this._renderColumnsTagPrint,
          setColumnsTagPrint: this.setColumnsTagPrint
        }, this.props, {
          columnsTag: this.state.columnsTag,
          columnsTagPrint: this.state.columnsTagPrint
        }));
      }
    }]);

    return withColumnsTag;
  }(_react2.default.Component);

  withColumnsTag.defaultProps = {};

  withColumnsTag.propTypes = {
    tHead: _propTypes2.default.object,
    columnsTag: _propTypes2.default.object
  };

  return withColumnsTag;
}